import random

LOUP = "loup"
SERPENT = "serpent"
CHEVAL = "cheval"
DRAGON = "dragon"
SANGLIER = "sanglier"
AIGLE = "aigle"

DE_NOIR = [LOUP, SERPENT, CHEVAL, DRAGON, SANGLIER, AIGLE]

def est_blanc(face):
    return face in DE_BLANC

def nb_des_blancs(combinaison):
    total = 0
    for face in combinaison:
        if est_blanc(face):
            total += 1
    return total

def arg_max(liste):
    maxi = liste[0]
    indice_maxi = 0
    for indice in range(1, len(liste)):
        if liste[indice] > maxi:
            maxi = liste[indice]
            indice_maxi = indice
    return indice_maxi

def appliquer_des_noirs(combinaison, valeurs):
    """
    Cette fonction moodifie les valeurs des dés d'une combinaison
    en fonction des dés noirs qu'elle contient.
    combinaison: la combinaison à analyser
    valeurs: les valeur des dés après prise en compte de tous les
    effets des dés blancs
    La fonction modifie directement (dans la variable "valeurs") les
    valeurs des dés en fonction des dés noirs présents.
    """

defi16 = [HEROS, HEROS, HEROS, CAPITAINE,SOLDAT, SOLDAT, MAGE, LOUP]
defi19 = [HEROS, MAUDIT, MAUDIT, MAUDIT, SOLDAT, SOLDAT, MAGE, SERPENT]
defi22 = [HEROS, CAPITAINE, CAPITAINE, CAPITAINE, SOLDAT, SOLDAT, MAGE, CHEVAL]
defi25 = [SOLDAT, SOLDAT, SOLDAT, MAUDIT, MAUDIT, MAUDIT, MAGE, DRAGON]

def verification_resoudre_loup():
    solution = resoudre(defi16)
    armee1 = [HEROS, HEROS, CAPITAINE, SOLDAT]
    armee2 = [HEROS, SOLDAT, MAGE, LOUP]
    assert comparer_couples(solution, (armee1, armee2))

def verification_resoudre_serpent():
    solution = resoudre(defi19)
    armee1 = [HEROS, MAUDIT, MAUDIT, MAUDIT]
    armee2 = [SOLDAT, SOLDAT, MAGE, SERPENT]
    assert comparer_couples(solution, (armee1, armee2))

def verification_resoudre_cheval():
    solution = resoudre(defi22)
    armee1 = [HEROS, CAPITAINE, CAPITAINE, SOLDAT]
    armee2 = [CAPITAINE, SOLDAT, MAGE, CHEVAL]
    assert comparer_couples(solution, (armee1, armee2))
    
def verification_resoudre_dragon():
    solution = resoudre(defi25)
    armee1 = [SOLDAT, SOLDAT, SOLDAT, DRAGON]
    armee2 = [MAUDIT, MAUDIT, MAUDIT, MAGE]
    assert comparer_couples(solution, (armee1, armee2))
    
